import Vue from 'vue'
import Vuex from 'vuex'

import actions from '@/store/actions'

import currency from '@/store/modules/currency'
import customer from '@/store/modules/customer'
import date from '@/store/modules/date'
import journal from '@/store/modules/journal'
import payment from '@/store/modules/payment'
import product from '@/store/modules/product'
import user from '@/store/modules/user'

Vue.use(Vuex)

const store = new Vuex.Store({
    actions,
    modules: {
        currency,
        customer,
        date,
        journal,
        payment,
        product,
        user
    },
    strict: false
})

export default store