import { SET_CUSTOMERS, SET_LOADING_CUSTOMERS } from  '../../constants/mutationTypes'
import { INIT_CUSTOMERS } from  '../../constants/actionTypes'

const initialState = {
    customers: [],
    loadingCustomers: false
}

const state = {
    customers: initialState.customers,
    loadingCustomers: !initialState.loadingCustomers
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    customers(state) {
        return state.customers
    },
    /**
     * 
     * @param {*} state 
     */
    loadingCustomers(state) {
        return state.loadingCustomers
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_CUSTOMERS] (state, payload) {
        state.customers = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_LOADING_CUSTOMERS] (state, payload) {
        state.loadingCustomers = !!payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    [INIT_CUSTOMERS] ({ commit }, payload) {
        commit(SET_CUSTOMERS, payload)
        commit(SET_LOADING_CUSTOMERS)
    }
}

export default {
    state,
    getters,
    actions,
    mutations
}