import { SET_DATE, SET_LOADING_DATE } from '@/constants/mutationTypes'
import { INIT_DATE } from '@/constants/actionTypes'

const initialState = {
    date: null,
    loadingDate: false
}

const state = {
    date: initialState.date,
    loadingDate: !initialState.loadingDate
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    date(state) {
        return state.date
    },
    /**
     * 
     * @param {*} state 
     */
    loadingDate(state) {
        return state.loadingDate
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_DATE] (state, payload) {
        state.date = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_LOADING_DATE] (state, payload) {
        state.loadingDate = !!payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    [INIT_DATE] ({ commit }, payload) {
        commit(SET_DATE, payload)
        commit(SET_LOADING_DATE)
    }
}

export default {
    state,
    getters,
    actions,
    mutations
}