import { SET_JOURNALS, SET_LOADING_JOURNALS } from '@/constants/mutationTypes'
import { INIT_JOURNALS } from '@/constants/actionTypes'

const initialState = {
    journals: [],
    loadingJournals: false
}

const state = {
    journals: initialState.journals,
    loadingJournals: !initialState.loadingJournals
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    journals(state) {
        return state.journals
    },
    /**
     * 
     * @param {*} state 
     */
    loadingJournals(state) {
        return state.loadingJournals
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_JOURNALS] (state, payload) {
        state.journals = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_LOADING_JOURNALS] (state, payload) {
        state.loadingJournals = !!payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    [INIT_JOURNALS] ({ commit }, payload) {
        commit(SET_JOURNALS, payload)
        commit(SET_LOADING_JOURNALS)
    }
}

export default {
    state,
    getters,
    actions,
    mutations
}