import { SET_PRODUCTS, SET_LOADING_PRODUCTS } from '@/constants/mutationTypes'
import { INIT_PRODUCTS } from '@/constants/actionTypes'

const initialState = {
    products: [],
    loadingProducts: false
}

const state = {
    products: initialState.products,
    loadingProducts: !initialState.loadingProducts
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    users(state) {
        return state.products
    },
    /**
     * 
     * @param {*} state 
     */
    loadingProducts(state) {
        return state.loadingProducts
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_PRODUCTS] (state, payload) {
        state.products = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_LOADING_PRODUCTS] (state, payload) {
        state.loadingProducts = !!payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    [INIT_PRODUCTS] ({ commit }, payload) {
        commit(SET_PRODUCTS, payload)
        commit(SET_LOADING_PRODUCTS)
    }
}

export default {
    state,
    getters,
    actions,
    mutations
}

